SystemOrganization addCategory: #MCConverter!

Object subclass: #MDProvisionalSnapshot
	instanceVariableNames: 'version elementVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MCConverter'!

!MDProvisionalSnapshot methodsFor: 'base operations' stamp: 'cwp 4/3/2005 00:48'!
linkElementsIn: aConverter 
	| ancestorSnapshots |
	ancestorSnapshots := self ancestorSnapshotsIn: aConverter.
	elementVersions do: 
		[:ev | ev ancestors: (ancestorSnapshots collect: 
			[:as | as versionForElement: ev element])]! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/3/2005 00:03'!
convertVariablesFromClass: aClassDefinition
	| class element |
	aClassDefinition variables do: 
		[:variable |
		variable isInstanceVariable ifTrue: [class _ MDInstVarElement].
		variable isClassVariable ifTrue: [class _ MDClassVarElement].
		variable isClassInstanceVariable ifTrue: [class _ MDClassInstVarElement].
		variable isPoolImport ifTrue: [class _ MDPoolImportElement].
		element _ class className: aClassDefinition className name: variable name.
		self addElement: element state: MDPropertyDictionary new]! !

!MDProvisionalSnapshot methodsFor: 'base operations' stamp: 'cwp 4/3/2005 03:47'!
collapseHistory
	elementVersions _ elementVersions collect: [:ev | ev originalAncestor]! !

!MDProvisionalSnapshot methodsFor: 'accessing' stamp: 'cwp 4/3/2005 12:52'!
asSnapshot
	^ MDSnapshot withVersions: (elementVersions collect: [:ea | ea asElementVersion])! !

!MDProvisionalSnapshot methodsFor: 'accessing' stamp: 'cwp 4/3/2005 01:48'!
versionForElement: anElement
	^ elementVersions 
		detect: [:ea | ea element = anElement]
		ifNone: [nil]! !

!MDProvisionalSnapshot methodsFor: 'accessing' stamp: 'cwp 4/3/2005 00:46'!
ancestorSnapshotsIn: aConverter 
	| ancestorVersions |
	ancestorVersions := version info ancestors 
				collect: [:ea | aConverter at: ea id ifAbsent: [nil]].
	ancestorVersions := ancestorVersions copyWithout: nil.
	^ancestorVersions! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/3/2005 20:48'!
convertLog
	| element state |
	element _ MDLogElement new.
	element setName: version package name type: #Package.
	state _ MDPropertyDictionary new.
	state 
		id: version info id asString;
		name: version info name;
		author: version info author;
		comment: version info message.
	self addElement: element state: state
	! !

!MDProvisionalSnapshot methodsFor: 'base operations' stamp: 'cwp 4/3/2005 12:12'!
findRemovalsSince: aProvisionalSnapshot
	aProvisionalSnapshot elementVersions do:
		[:ancestor |
		(elementVersions anySatisfy: [:ea | ea element = ancestor element])
			ifFalse: [self addElement: ancestor element state: nil]]! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/2/2005 23:14'!
convertClassDefinition: aDefinition
	| element state |
	element _ MDClassElement className: aDefinition className.
	state _ MDPropertyDictionary new.
	state 
		category: aDefinition category;
		format: aDefinition type;
		superclassName: aDefinition superclassName.
	self addElement: element state: state.
	aDefinition hasComment ifTrue: [self convertClassComment: aDefinition].
	self convertVariablesFromClass: aDefinition.! !

!MDProvisionalSnapshot methodsFor: 'base operations' stamp: 'cwp 4/3/2005 20:12'!
convertElements
	elementVersions _ Set new.
	self convertLog.
	self convertMetadata.
	version snapshot definitions do:
		[:ea | self convertDefinition: ea].! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/3/2005 19:39'!
convertMetadata
	| element state |
	element _ MDMetadataElement new.
	element setName: version package name type: #Package.
	state _ MDPropertyDictionary new.
	state 
		branch: self branchName;
		versionNumber: self versionNumber.
	self addElement: element state: state
	! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/2/2005 22:14'!
convertDefinition: aDefinition
	aDefinition isClassDefinition ifTrue: [^ self convertClassDefinition: aDefinition].
	aDefinition isMethodDefinition ifTrue: [^ self convertMethodDefinition: aDefinition].
	! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/3/2005 20:12'!
branchName
	| name |
	name _ version info name copyUpToLast: $-.
	^ name size > version package name size
		ifTrue: [name allButFirst: version packageName size + 1]
		ifFalse: [nil]
! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/3/2005 21:02'!
versionNumber
	^ (version info name copyAfterLast: $.) asNumber! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/3/2005 21:36'!
convertMethodDefinition: aDefinition
	| element state |
	element _ MDMethodElement 
				className: aDefinition className
				selector: aDefinition selector
				classIsMeta: aDefinition classIsMeta.
	state _ MDPropertyDictionary new.
	state
		author: (aDefinition timeStamp copyUpTo: $ );
		category: aDefinition category;
		source: aDefinition source;
		timeStamp: (aDefinition timeStamp isEmpty ifFalse: [aDefinition fullTimeStamp]).
	self addElement: element state: state
		! !

!MDProvisionalSnapshot methodsFor: 'accessing' stamp: 'cwp 4/3/2005 00:56'!
elementVersions
	^ elementVersions! !

!MDProvisionalSnapshot methodsFor: 'base operations' stamp: 'cwp 4/3/2005 00:46'!
findRemovalsIn: aConverter 
	(self ancestorSnapshotsIn: aConverter) 
		do: [:ea | self findRemovalsSince: ea]! !

!MDProvisionalSnapshot class methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2005 21:52'!
fromVersion: aVersion
	^ self new setVersion: aVersion! !

!MDProvisionalSnapshot methodsFor: 'base operations' stamp: 'cwp 4/3/2005 12:46'!
assignTimestamps
	| ts |
	ts _ TimeStamp date: version info date time: version info time.
	elementVersions do: [:ea | ea timestamp: ts]	! !

!MDProvisionalSnapshot methodsFor: 'initializing' stamp: 'cwp 4/3/2005 04:53'!
setVersion: aVersion
	version _ aVersion! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/3/2005 19:36'!
nameParts
	| name properties |
	properties _ MDPropertyDictionary new.
	name _ version info name copyUpToLast: $..
	name last isDigit 
		ifFalse: [properties package: name]
		ifTrue:
				[properties
					package: (name copyUpToLast:  $-);
					author: ((name copyAfterLast: $-) upTo: $.);
					version: ((name copyAfterLast: $-) copyAfter: $.)].
	^ properties! !

!MDProvisionalSnapshot methodsFor: 'element conversion' stamp: 'cwp 4/2/2005 23:10'!
convertClassComment: aDefinition
	| element state |
	element _ MDClassCommentElement className: aDefinition className.
	state _ MDPropertyDictionary new.
	state
		text: aDefinition comment;
		author: (aDefinition commentStamp copyUpTo: $ );
		timeStamp: (TimeStamp fromMethodTimeStamp: aDefinition commentStamp).
	self addElement: element state: state! !

!MDProvisionalSnapshot methodsFor: 'accessing' stamp: 'cwp 4/2/2005 22:35'!
addElement: element state: state
	elementVersions add: (MDProvisionalVersion element: element state: state)! !

!MDProvisionalSnapshot methodsFor: 'accessing' stamp: 'cwp 4/3/2005 03:37'!
version
	^ version! !

Object subclass: #MDProvisionalVersion
	instanceVariableNames: 'element ancestors state timestamp complete'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MCConverter'!

!MDProvisionalVersion methodsFor: 'accessing' stamp: 'cwp 4/3/2005 04:49'!
ancestry
	| ancestry |
	ancestry _ Set new.
	ancestors do: [:ea | ea contributeToAncestry: ancestry].
	^ ancestry! !

!MDProvisionalVersion methodsFor: 'converting' stamp: 'cwp 4/3/2005 12:14'!
asElementVersion
	^ complete ifNil: [complete _ MDElementVersion
								snapshot: self snapshot
								ancestry: (self ancestry collect: [:ea | ea hashstamp])
								timestamp: timestamp]! !

!MDProvisionalVersion methodsFor: 'printing' stamp: 'cwp 4/3/2005 03:21'!
printOn: aStream
	aStream 
		nextPutAll: 'ProvisionalVersion';
		nextPut: $<;
		print: self identityHash;
		nextPut: $>! !

!MDProvisionalVersion class methodsFor: 'as yet unclassified' stamp: 'cwp 4/2/2005 22:37'!
element: anElement state: anElementSnapshot
	^ self new setElement: anElement state: anElementSnapshot! !

!MDProvisionalVersion methodsFor: 'accessing' stamp: 'cwp 4/3/2005 01:47'!
ancestors
	^ ancestors! !

!MDProvisionalVersion methodsFor: 'accessing' stamp: 'cwp 4/2/2005 23:16'!
element
	^ element! !

!MDProvisionalVersion methodsFor: 'accessing' stamp: 'cwp 4/2/2005 23:16'!
state
	^ state! !

!MDProvisionalVersion methodsFor: 'initialize-release' stamp: 'cwp 4/2/2005 22:37'!
setElement: anElement state: anElementSnapshot
	element _ anElement.
	state _ anElementSnapshot! !

!MDProvisionalVersion methodsFor: 'accessing' stamp: 'cwp 4/3/2005 01:50'!
ancestors: anArray
	ancestors _ anArray copyWithout: nil! !

!MDProvisionalVersion methodsFor: 'accessing' stamp: 'cwp 4/3/2005 04:46'!
snapshot
	^ state
		ifNil: [MDElementRemoval forElement: element]
		ifNotNil: 
			[| def |
			def _ MDElementDefinition forElement: element.
			def properties addAll: state.
			def]! !

!MDProvisionalVersion methodsFor: 'accessing' stamp: 'cwp 4/3/2005 12:07'!
timestamp: aTimeStamp
	timestamp _ aTimeStamp! !

!MDProvisionalVersion methodsFor: 'accessing' stamp: 'cwp 4/3/2005 03:49'!
originalAncestor
	^ (ancestors detect: [:ea | ea state = state] ifNone: [^ self]) originalAncestor! !

!MDProvisionalVersion methodsFor: 'accessing' stamp: 'cwp 4/3/2005 12:08'!
contributeToAncestry: aSet
	aSet add: self asElementVersion.
	ancestors do: [:ea | ea contributeToAncestry: aSet]! !

Object subclass: #MDRepositoryConverter
	instanceVariableNames: 'source destination snapshots packageName progress'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MCConverter'!

!MDRepositoryConverter methodsFor: 'operations' stamp: 'cwp 4/4/2005 00:04'!
convert: aString
	packageName _ aString.
	self doAll: #(read translate write)! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 00:28'!
at: key ifAbsent: aBlock
	^ snapshots at: key ifAbsent: aBlock! !

!MDRepositoryConverter methodsFor: 'operations' stamp: 'cwp 4/4/2005 00:04'!
translate
	self doAll: #(convertElements findRemovals assignTimestamps linkElements collapseHistory)
! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/4/2005 00:08'!
doAll: anArray
	progress push: anArray size.
	anArray do: [:ea | self perform: ea] separatedBy: [progress advance].
	progress advance; pop! !

!MDRepositoryConverter methodsFor: 'accessing' stamp: 'cwp 4/3/2005 04:31'!
destination: anMDRepository
	destination _ anMDRepository! !

!MDRepositoryConverter methodsFor: 'operations' stamp: 'cwp 4/4/2005 00:11'!
write
	| versions |
	versions _ Set new.
	snapshots do: [:ea | versions addAll: ea elementVersions].
	self with: versions do: [:ea | destination put: ea asElementVersion].
	snapshots do: [:ea | destination put: ea asSnapshot]! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 21:44'!
packageNames
	| names |
	names _ Set new.
	source readableFileNames do: [:ea | names add: (ea copyUpToLast: $-)].
	^ names ! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 23:45'!
linkElements
	self with: snapshots do: [:ea | ea linkElementsIn: self]! !

!MDRepositoryConverter methodsFor: 'operations' stamp: 'cwp 4/4/2005 01:40'!
read
	| version |
	snapshots _ Dictionary new.
	self 
		with: self fileNames 
		do: [:filename | 
			version _ [source versionFromFileNamed: filename]
						on: ProgressInitiationException
						do: [:ex | ex resume].
			snapshots
				at: version info id 
				put: (MDProvisionalSnapshot fromVersion: version)].! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 23:45'!
collapseHistory
	self with: snapshots do: [:ea | ea collapseHistory]! !

!MDRepositoryConverter methodsFor: 'accessing' stamp: 'cwp 4/3/2005 04:31'!
source: anMCRepository
	source _ anMCRepository! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 23:42'!
with: aCollection do: aBlock
	progress push: aCollection size.
	aCollection do: [:ea | aBlock value: ea. progress advance].
	progress pop! !

!MDRepositoryConverter methodsFor: 'operations' stamp: 'cwp 4/3/2005 23:41'!
convertAll
	self 
		with: self packageNames 
		do: [:ea | self convert: ea]! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 23:44'!
findRemovals
	self with: snapshots do: [:ea | ea findRemovalsIn: self]! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 23:45'!
assignTimestamps
	self with: snapshots do: [:ea | ea assignTimestamps]! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 21:31'!
fileNames
	^ source readableFileNames select: [:ea | ea beginsWith: packageName]! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 23:38'!
initialize
	progress _ MDNestedTask withLabel: 'Converting...'! !

!MDRepositoryConverter class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 04:30'!
forDirectoryNamed: aString
	| inst source |
	source _ MCDirectoryRepository new.
	source directory: (FileDirectory default directoryNamed: aString).
	inst _ self new.
	inst source: source.
	inst destination: (MDFileRepository named: aString).
	^ inst! !

!MDRepositoryConverter methodsFor: 'private' stamp: 'cwp 4/3/2005 23:44'!
convertElements
	self with: snapshots do: [:ea | ea convertElements]! !

!MDRepositoryConverter methodsFor: 'accessing' stamp: 'cwp 4/3/2005 03:31'!
snapshots
	^ snapshots! !

Object subclass: #MDNestedTask
	instanceVariableNames: 'bar stack value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MCConverter'!

!MDNestedTask methodsFor: 'public' stamp: 'cwp 4/4/2005 01:30'!
update
	bar value: (stack inject: 0 asFraction into: [:sum :ea | sum inc: ea])! !

!MDNestedTask class methodsFor: 'as yet unclassified' stamp: 'cwp 4/3/2005 22:27'!
withLabel: aString
	^ self basicNew setLabel: aString! !

!MDNestedTask methodsFor: 'public' stamp: 'cwp 4/4/2005 01:08'!
push: aNumber
	stack add: (Fraction numerator: 0 denominator: aNumber)! !

!MDNestedTask methodsFor: 'initialize-release' stamp: 'cwp 4/3/2005 22:28'!
setLabel: aString
	bar _ SystemProgressMorph label: aString min: 0.0 max: 1.0.
	stack _ OrderedCollection new.
	value _ 0.0! !

!MDNestedTask methodsFor: 'public' stamp: 'cwp 4/4/2005 01:21'!
advance
	
	| top |
	top _ stack last.
	top _ Fraction
			numerator: top numerator + 1
			denominator: top denominator.
	stack at: stack size put: top.
	self update! !

!MDNestedTask methodsFor: 'public' stamp: 'cwp 4/4/2005 01:08'!
pop
	stack removeLast.
	stack isEmpty ifTrue: [SystemProgressMorph close: bar]! !

!Fraction methodsFor: '*mcconverter-arithmetic' stamp: 'cwp 4/4/2005 01:29'!
inc: aFraction
	^ Fraction
		numerator: (numerator * denominator * aFraction denominator) 
						+ (aFraction numerator * denominator)
		denominator: (denominator * denominator * aFraction denominator)! !
